#include <PA9.h>
#include "all_gfx.h"

int main(void){
 
	PA_Init();
	
	PA_LoadDefaultText(1, 0);
	PA_OutputSimpleText(1, 1, 1, "Usa la cruceta de direcciones\npara mover el sprite.");
	PA_OutputSimpleText(1, 1, 4, "Usa A/Y para cambiar el zoom\nen el eje X.");
	PA_OutputSimpleText(1, 1, 7, "Usa X/B para cambiar el zoom\nen el eje Y.");
	PA_OutputSimpleText(1, 1, 10, "Usa L/R para cambiar la\nrotacion del sprite.");
	
	// Variables para modificar el sprite.
	int x = 256/2 - 16/2;
	int y = 192/2 - 16/2;
	u16 angle = 0;
	u16 zoomX = 256;
	u16 zoomY = 256;
 
	// Cargamos la paleta para sprites.
	PA_LoadSpritePal(0, 0, (void*)sprite_nave_Pal);
	
	// Cargamos el sprite.
	PA_CreateSprite(0, 0, (void*)sprite_nave_Sprite, OBJ_SIZE_16X16, 1, 0, x, y);
 
	// Permitimos que se pueda rotar y escalar.
	PA_SetSpriteRotEnable(0, 0, 0);
 
	while(1){
	  
		// Actualizamos variables a partir de la entrada de usuario.
		x += Pad.Held.Right - Pad.Held.Left;
		y += Pad.Held.Down - Pad.Held.Up;
		
		angle += Pad.Held.L - Pad.Held.R;
		
		zoomX += Pad.Held.Y - Pad.Held.A;
		zoomY += Pad.Held.B - Pad.Held.X;
		
		if(x < 0) x = 0;
		if(x > 256 - 16) x = 256 - 16;
		if(y < 0) y = 0;
		if(y > 192 - 16) y = 192 - 16;

		angle &= 511;
		
		if(Pad.Held.Select){ // Reset.
			x = 256/2 - 16/2;
			y = 192/2 - 16/2;
			angle = 0;
			zoomX = 256;
			zoomY = 256;
		}
		
		// Aplicamos los cambios.
		PA_SetSpriteXY(0, 0, x, y);
		PA_SetRotset(0, 0, angle, zoomX, zoomY);
		
		PA_WaitForVBL();
 
	}
 
return 0;
}