#include <PA9.h>
#include "all_gfx.h"

int main(void){
  
	int pause = 0;
 
	PA_Init();
	
	PA_LoadDefaultText(1, 1);
	PA_OutputSimpleText(1, 1, 1, "A - pausar/reanudar animacion\nL - fotograma hacia atras\nR - fotograma hacia delante");
 
	// Cargamos la paleta para sprites.
	PA_LoadSpritePal(0, 0, (void*)explosion_Pal);
	
	// Cargamos el sprite.
	PA_CreateSprite(0, 0, (void*)explosion_Sprite, OBJ_SIZE_32X32, 1, 0, 127-32/2, 192/2-32/2);
 
	// Comenzamos la animacion entre los frames 0 y 6 a 7 frames por segundo.
	PA_StartSpriteAnim(0, 0, 0, 6, 7);
	
 
	while(1){
	  
		// Al pulsar A, la animación se pausa/pone de nuevo en marcha.
		if(Pad.Released.A){
			if(!pause) pause = 1;
			else pause = 0;
			PA_SpriteAnimPause(0, 0, pause);
		}
		
		// Con R avanzamos un frame.
		if(pause && Pad.Released.R){
			int frame = PA_GetSpriteAnimFrame(0, 0) + 1;
			if(frame == 7) frame = 0;
			PA_SetSpriteAnim(0, 0, frame);
		}
		
		// Con L retrocedemos un frame.
		if(pause && Pad.Released.L){
			int frame = PA_GetSpriteAnimFrame(0, 0) - 1;
			if(frame == -1) frame = 6;
			PA_SetSpriteAnim(0, 0, frame);
		}
		
		PA_WaitForVBL();
 
	}
 
return 0;
}