#include <PA9.h>
#include <maxmod9.h>

// Se incluye el banco de sonidos (generado automáticamente).
#include "soundbank_bin.h"
#include "soundbank.h"

int main(){
	PA_Init();
	PA_LoadDefaultText(0, 0);
	
	// Impedimos que la consola se suspenda al cerrarla.
	PA_SetAutoCheckLid (0);
	
	int volume = 1024;
	int tempo = 1024;
	int pitch = 1024;

	// Se inicializa el sistema de audio.
	mmInitDefaultMem((mm_addr)soundbank_bin);

	// Se carga la música en memoria.
	mmLoad(MOD_MUSIC);
	// Y se comienza a reproducir.
	mmStart(MOD_MUSIC, MM_PLAY_LOOP);

	PA_OutputSimpleText(0, 1, 1, "Reproduccion de modulos.");
	PA_OutputSimpleText(0, 1, 2, "________________________");
	PA_OutputSimpleText(0, 2, 3,  "Pausar/reanudar: A");
	PA_OutputSimpleText(0, 2, 4,  "Volumen: - v / + ^");
	PA_OutputSimpleText(0, 2, 5 , "Tempo:   - < / + >");
	PA_OutputSimpleText(0, 2, 6,  "Altura:  - L / + R");
        PA_OutputSimpleText(0, 1, 7, "_________________________");

	while(1){
  
		// Pausa.
		if(Pad.Newpress.A && mmActive()) mmPause();
		else if(Pad.Newpress.A && !mmActive()) mmResume();

		// Control del volumen.
		volume += Pad.Held.Up - Pad.Held.Down;
		if(volume > 1024) volume = 1024;
		if(volume < 0) volume = 0;
		
		mmSetModuleVolume(volume);

		// Control del tempo.
		tempo += Pad.Held.Right - Pad.Held.Left;
		if(tempo > 2048) tempo = 2048;
		if(tempo < 512) tempo = 512;

		mmSetModuleTempo(tempo);
		
		// Control de la altura.
		pitch += Pad.Held.R - Pad.Held.L;
		if(pitch > 2048) pitch = 2048;
		if(pitch < 0) pitch = 0;

		mmSetModulePitch(pitch);

		// Texto informativo.
		if(mmActive()) PA_OutputSimpleText(0, 4, 9, "Reproduciendo...");
		else PA_OutputSimpleText(0, 4, 9,           "Pausado.        ");
		PA_OutputText(0, 4, 10, "Volumen: %d     ", volume);
		PA_OutputText(0, 4, 11, "Tempo: %d       ", tempo);
		PA_OutputText(0, 4, 12, "Altura: %d     ", pitch);
		PA_WaitForVBL();

    }
}